= How do I automatically close tickets when I commit changes? =
[[TOC(heading=How do I...?,depth=1,HowTo/*)]]

Trac tickets are integrated with the Subversion repository commits via the 
[http://trac.edgewall.org/attachment/wiki/TracMultipleProjects/ComprehensiveSolution/trac-post-commit-hook trac-post-commit-hook]. 
When you commit changes to Subversion, the hook watches the commit message and closes or annotates
any tickets that are referred to.

The hook searches commit messages for text in the form of:

 * command !#1
 * command !#1, !#2
 * command !#1 & !#2 
 * command !#1 and !#2

Instead of the short-hand syntax "!#1", "!ticket:1" can be used as well, e.g.:

 * command !ticket:1
 * command !ticket:1, !ticket:2
 * command !ticket:1 & !ticket:2 
 * command !ticket:1 and !ticket:2

In addition, the ':' character can be omitted and issue or bug can be used
instead of ticket.

You can have more than one command in a message. The following commands
are supported. There is more than one spelling for each command, to make
this as user-friendly as possible.

  `close`, `closed`, `closes`, `fix`, `fixed`, `fixes`
     The specified issue numbers are closed with the contents of this
     commit message being added to it. 
  `references`, `refs`, `addresses`, `re`, `see` 
     The specified issue numbers are left in their current status, but 
     the contents of this commit message are added to their notes. 

A fairly complicated example of what you can do is with a commit message of:

    Changed blah and foo to do this or that. Fixes !#10 and !#12, and refs !#15.

This will close !#10 and !#12, and add a note to !#15.

=== Installation Details ===

The `trac-post-commit-hook` is installed at `/var/lib/trac/contrib/trac-post-commit-hook`, and
is hooked to Subversion via `/var/lib/svn/repos/secureci/hooks/post-commit`. 

<%= node['trac']['wiki']['footer'] %>